#ifndef MYX_MATH_FUNCTIONS_HPP_
#define MYX_MATH_FUNCTIONS_HPP_

#pragma once

#include <boost/math/special_functions/pow.hpp>
#include <cmath>
#include <type_traits>

namespace myx {

namespace math {

/*!
 * \brief pow2    Возведение в квадрат
 * \param value   Значение
 * \return        Квадрат значения
 */
template < typename T >
auto pow2( T const& value ) -> decltype( boost::math::pow< 2 >( value ) )
{
	return( boost::math::pow< 2 >( value ) );
}

} // namespace math

} // namespace myx


#endif // MYX_MATH_FUNCTIONS_HPP_
